Bug 826668 - gridengine uninstall script(s) failed, causing preupgrade to abort, cannot upgrade to f17 cleanly
gridengine uninstall script(s) failed, causing preupgrade to abort, cannot up...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: gridengine (Show other bugs)
16
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Orion Poplawski
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-05-30 14:04 EDT by Hin-Tak Leung
Modified: 2012-06-09 21:35 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-06-09 21:32:34 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Hin-Tak Leung 2012-05-30 14:04:32 EDT
Description of problem:
using preupgrade to upgrade from f16 to f17. During the clean-up stage towards the end, gridengine's uninstall failed. This causes preupgrade to abort, and system does not finishe upgrade - leaving behind the grub2 'upgrade' items, does not put new kernel in the grub2 menu (although new kernel is apparently installed). All in all, it is a mess in the rpm database, and the grub2 menu.

Version-Release number of selected component (if applicable):
The two versions left behind, according to rpm -q gridengine, 
gridengine-6.2u5p2-7.fc16.3
gridengine-2011.11-3.svn131.fc17

How reproducible:
Once (obvious this is unpleasant enough I don't want to see again...)

Steps to Reproduce:
1. install older gridengine
2. try to upgrade to new with yum
3.
  
Actual results:
yum aborted.


Expected results:
yum continues, and preupgrade continues to do the clean-up and also tidy up the boot menu, put the new kernel into the boot menu, etc.

Additional info:
Comment 1 Orion Poplawski 2012-05-30 15:31:52 EDT
Are there any logs that recorded what the error was?  Are there any other gridengine rpms installed (-execd, -qmon, etc)?
Comment 2 Hin-Tak Leung 2012-05-30 15:39:23 EDT
Unfortunately preupgrade does not keep much record around; but 
I keep a list of packages before and after upgrade (rpm -qa).

$ grep gridengine beforelist
gridengine-devel-6.2u5p2-7.fc16.3.x86_64
gridengine-6.2u5p2-7.fc16.3.x86_64
gridengine-qmon-6.2u5p2-7.fc16.3.x86_64
gridengine-qmaster-6.2u5p2-7.fc16.3.x86_64
gridengine-execd-6.2u5p2-7.fc16.3.x86_64

$ grep gridengine afterlist
gridengine-6.2u5p2-7.fc16.3.x86_64
gridengine-devel-2011.11-3.svn131.fc17.x86_64
gridengine-2011.11-3.svn131.fc17.x86_64
gridengine-qmaster-2011.11-3.svn131.fc17.x86_64
gridengine-qmon-2011.11-3.svn131.fc17.x86_64
gridengine-execd-2011.11-3.svn131.fc17.x86_64

Seems that only the main package failed to clean up (and caused the rest of preupgrade to be unfinished).
Comment 3 Orion Poplawski 2012-05-30 18:33:34 EDT
Can you attach /root/upgrade.log?
Comment 4 Hin-Tak Leung 2012-05-30 19:31:56 EDT
(In reply to comment #3)
> Can you attach /root/upgrade.log?

Argh, you got it... The last two lines of that is:

/usr/bin/qsub-ge has not been configured as an alternative for qsub
error: %preun(gridengine-6.2u5p2-7.fc16.3.x86_64) scriptlet failed, exit status 2

# ls -l /etc/alternatives/qsub
lrwxrwxrwx. 1 root root 20 May 24 19:32 /etc/alternatives/qsub -> /usr/bin/qsub-torque

# ls -l /usr/bin/qsub*
lrwxrwxrwx. 1 root root      22 May 24 19:32 /usr/bin/qsub -> /etc/alternatives/qsub
-rwxr-xr-x. 1 root root 1701448 Apr 17 18:36 /usr/bin/qsub-ge
-rwxr-xr-x. 1 root root   54352 Feb  5 13:31 /usr/bin/qsub-torque

I have torque also. (for development purposes...)
Comment 5 Orion Poplawski 2012-05-30 22:21:04 EDT
Can you please attach the entire upgrade.log to this report?  Thanks.

I'm starting to think that the whole alternatives system may not have been taken into consideration with the usrmove feature.  We'll see.
Comment 6 Orion Poplawski 2012-05-30 22:30:57 EDT
Well, usrmove has nothing to do with it I think.
Comment 7 Orion Poplawski 2012-05-30 23:17:25 EDT
Any chance you have a backup of /var/lib/alternatives from before the upgrade?
Comment 8 Hin-Tak Leung 2012-05-31 05:38:20 EDT
(In reply to comment #7)
> Any chance you have a backup of /var/lib/alternatives from before the
> upgrade?

What you saw in comment 4 was essentially before the upgrade (I only started it late 29th May). 

# ls -l /var/lib/alternatives/q*
-rw-r--r--. 1 root root 858 May 24 19:32 /var/lib/alternatives/qsub

Its content only talks about torque.


# rpm -q --scripts gridengine
...
preuninstall scriptlet (using /bin/sh):
alternatives --remove qsub /usr/bin/qsub-ge
...

I assume this is where it failed - the packager did not think of somebody installing two grid-computing packages simultaneously... it probably should do

alternatives --remove qsub /usr/bin/qsub-ge || /bin/true

instead, or something?
Comment 9 Fedora Update System 2012-05-31 18:36:17 EDT
gridengine-6.2u5-10.fc15.5 has been submitted as an update for Fedora 15.
https://admin.fedoraproject.org/updates/gridengine-6.2u5-10.fc15.5
Comment 10 Fedora Update System 2012-05-31 18:36:28 EDT
gridengine-6.2u5p2-7.fc16.4 has been submitted as an update for Fedora 16.
https://admin.fedoraproject.org/updates/gridengine-6.2u5p2-7.fc16.4
Comment 11 Fedora Update System 2012-06-01 12:56:05 EDT
Package gridengine-6.2u5-10.fc15.5:
* should fix your issue,
* was pushed to the Fedora 15 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing gridengine-6.2u5-10.fc15.5'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2012-8688/gridengine-6.2u5-10.fc15.5
then log in and leave karma (feedback).
Comment 12 Fedora Update System 2012-06-09 21:32:34 EDT
gridengine-6.2u5-10.fc15.5 has been pushed to the Fedora 15 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 13 Fedora Update System 2012-06-09 21:35:35 EDT
gridengine-6.2u5p2-7.fc16.4 has been pushed to the Fedora 16 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.